﻿Imports System
Imports System.IO
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Navigation

' Add a reference to WindowsBase.
Imports System.Windows.Threading

Partial Public Class Window1
	Public Sub New()
		MyBase.New()

		Me.InitializeComponent()

		' Insert code required on object creation below this point.
	End Sub

    Private WithEvents tmrProgress As New DispatcherTimer()

    Private Sub btnRewind_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        mmBear.Position = mmBear.Position.Add(New TimeSpan(0, 0, -5))
    End Sub
    Private Sub btnPlay_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        mmBear.Play()
        tmrProgress.Start()
    End Sub
    Private Sub btnPause_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        mmBear.Pause()
        tmrProgress.Stop()
    End Sub
    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        mmBear.Stop()
        tmrProgress.Stop()
    End Sub
    Private Sub btnForward_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        mmBear.Position = mmBear.Position.Add(New TimeSpan(0, 0, 5))
    End Sub
    Private Sub btnBookmark_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        lstBookmarks.Items.Add(mmBear.Position)
    End Sub

    ' Jump to this bookmark.
    Private Sub lstBookmarks_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs)
        If (mmBear Is Nothing) Then Exit Sub
        If e.AddedItems.Count < 1 Then Exit Sub
        Dim bookmark As TimeSpan = e.AddedItems.Item(0)
        mmBear.Pause()
        mmBear.Position = bookmark
        scrProgress.Value = mmBear.Position.TotalSeconds
        lstBookmarks.SelectedIndex = -1
    End Sub

    ' Display the media's progress.
    Private Sub tmrProgress_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmrProgress.Tick
        scrProgress.Value = mmBear.Position.TotalSeconds
    End Sub

    ' Prepare the progress ScrollBar.
    Private Sub mmBear_MediaOpened(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        If mmBear.NaturalDuration.HasTimeSpan Then
            Dim ts As TimeSpan = mmBear.NaturalDuration.TimeSpan
            scrProgress.Maximum = ts.TotalSeconds
            scrProgress.SmallChange = 1
            scrProgress.LargeChange = ts.TotalSeconds / 10
        Else
            scrProgress.Visibility = Windows.Visibility.Hidden
        End If
    End Sub

    ' Go to the selected position.
    Private Sub scrPosition_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Controls.Primitives.ScrollEventArgs)
        mmBear.Position = TimeSpan.FromSeconds(e.NewValue)
    End Sub
End Class
